/* tracker-backend.c generated by valac 0.48.11, the Vala compiler
 * generated from tracker-backend.vala, do not modify */

/*
 * Copyright (C) 2010, Nokia <ivan.frade@nokia.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "libtracker-sparql/tracker-sparql.h"
#include "tracker-remote.h"
#include <gio/gio.h>
#include "tracker-bus.h"
#include "tracker-direct.h"

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _TrackerSparqlConnectionNewAsyncData TrackerSparqlConnectionNewAsyncData;

struct _TrackerSparqlConnectionNewAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TrackerSparqlConnectionFlags flags;
	GFile* store;
	GFile* ontology;
	GCancellable* cancellable;
	TrackerSparqlConnection* result;
	TrackerDirectConnection* conn;
	TrackerDirectConnection* _tmp0_;
	TrackerDirectConnection* _tmp1_;
	GError* _inner_error0_;
};

TrackerSparqlConnection* tracker_sparql_connection_remote_new (const gchar* url_base);
TrackerSparqlConnection* tracker_sparql_connection_bus_new (const gchar* service,
                                                            const gchar* object_path,
                                                            GDBusConnection* conn,
                                                            GError** error);
TrackerSparqlConnection* tracker_sparql_connection_new (TrackerSparqlConnectionFlags flags,
                                                        GFile* store,
                                                        GFile* ontology,
                                                        GCancellable* cancellable,
                                                        GError** error);
static void tracker_sparql_connection_new_async_data_free (gpointer _data);
void tracker_sparql_connection_new_async (TrackerSparqlConnectionFlags flags,
                                          GFile* store,
                                          GFile* ontology,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
TrackerSparqlConnection* tracker_sparql_connection_new_finish (GAsyncResult* _res_,
                                                               GError** error);
static gboolean tracker_sparql_connection_new_async_co (TrackerSparqlConnectionNewAsyncData* _data_);
static void tracker_sparql_connection_new_async_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);

TrackerSparqlConnection*
tracker_sparql_connection_remote_new (const gchar* url_base)
{
	TrackerRemoteConnection* _tmp0_;
	TrackerSparqlConnection* result = NULL;
	g_return_val_if_fail (url_base != NULL, NULL);
	_tmp0_ = tracker_remote_connection_new (url_base);
	result = (TrackerSparqlConnection*) _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

TrackerSparqlConnection*
tracker_sparql_connection_bus_new (const gchar* service,
                                   const gchar* object_path,
                                   GDBusConnection* conn,
                                   GError** error)
{
	GDBusConnection* dbus_conn = NULL;
	gchar* path = NULL;
	TrackerBusConnection* _tmp6_ = NULL;
	const gchar* _tmp7_;
	GDBusConnection* _tmp8_;
	TrackerBusConnection* _tmp9_;
	TrackerBusConnection* _tmp10_;
	GError* _inner_error0_ = NULL;
	TrackerSparqlConnection* result = NULL;
	g_return_val_if_fail (service != NULL, NULL);
	if (conn != NULL) {
		GDBusConnection* _tmp0_;
		_tmp0_ = _g_object_ref0 (conn);
		_g_object_unref0 (dbus_conn);
		dbus_conn = _tmp0_;
	} else {
		GDBusConnection* _tmp1_ = NULL;
		GDBusConnection* _tmp2_;
		GDBusConnection* _tmp3_;
		_tmp2_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (path);
			_g_object_unref0 (dbus_conn);
			return NULL;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (dbus_conn);
		dbus_conn = _tmp3_;
		_g_object_unref0 (_tmp1_);
	}
	if (object_path != NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (object_path);
		_g_free0 (path);
		path = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("/org/freedesktop/Tracker3/Endpoint");
		_g_free0 (path);
		path = _tmp5_;
	}
	_tmp7_ = path;
	_tmp8_ = dbus_conn;
	_tmp9_ = tracker_bus_connection_new (service, _tmp7_, _tmp8_, &_inner_error0_);
	_tmp6_ = _tmp9_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (path);
		_g_object_unref0 (dbus_conn);
		return NULL;
	}
	_tmp10_ = _tmp6_;
	_tmp6_ = NULL;
	result = (TrackerSparqlConnection*) _tmp10_;
	_g_object_unref0 (_tmp6_);
	_g_free0 (path);
	_g_object_unref0 (dbus_conn);
	return result;
}

TrackerSparqlConnection*
tracker_sparql_connection_new (TrackerSparqlConnectionFlags flags,
                               GFile* store,
                               GFile* ontology,
                               GCancellable* cancellable,
                               GError** error)
{
	TrackerDirectConnection* conn = NULL;
	TrackerDirectConnection* _tmp0_;
	TrackerDirectConnection* _tmp1_;
	GError* _inner_error0_ = NULL;
	TrackerSparqlConnection* result = NULL;
	_tmp0_ = tracker_direct_connection_new (flags, store, ontology, &_inner_error0_);
	conn = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = conn;
	g_initable_init ((GInitable*) _tmp1_, cancellable, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (conn);
		return NULL;
	}
	result = (TrackerSparqlConnection*) conn;
	return result;
}

static void
tracker_sparql_connection_new_async_data_free (gpointer _data)
{
	TrackerSparqlConnectionNewAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->store);
	_g_object_unref0 (_data_->ontology);
	_g_object_unref0 (_data_->cancellable);
	_g_object_unref0 (_data_->result);
	g_slice_free (TrackerSparqlConnectionNewAsyncData, _data_);
}

void
tracker_sparql_connection_new_async (TrackerSparqlConnectionFlags flags,
                                     GFile* store,
                                     GFile* ontology,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	TrackerSparqlConnectionNewAsyncData* _data_;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
	_data_ = g_slice_new0 (TrackerSparqlConnectionNewAsyncData);
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tracker_sparql_connection_new_async_data_free);
	_data_->flags = flags;
	_tmp0_ = _g_object_ref0 (store);
	_g_object_unref0 (_data_->store);
	_data_->store = _tmp0_;
	_tmp1_ = _g_object_ref0 (ontology);
	_g_object_unref0 (_data_->ontology);
	_data_->ontology = _tmp1_;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	tracker_sparql_connection_new_async_co (_data_);
}

TrackerSparqlConnection*
tracker_sparql_connection_new_finish (GAsyncResult* _res_,
                                      GError** error)
{
	TrackerSparqlConnection* result;
	TrackerSparqlConnectionNewAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
tracker_sparql_connection_new_async_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	TrackerSparqlConnectionNewAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tracker_sparql_connection_new_async_co (_data_);
}

static gboolean
tracker_sparql_connection_new_async_co (TrackerSparqlConnectionNewAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = tracker_direct_connection_new (_data_->flags, _data_->store, _data_->ontology, &_data_->_inner_error0_);
	_data_->conn = _data_->_tmp0_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp1_ = _data_->conn;
	_data_->_state_ = 1;
	g_async_initable_init_async ((GAsyncInitable*) _data_->_tmp1_, G_PRIORITY_DEFAULT, _data_->cancellable, tracker_sparql_connection_new_async_ready, _data_);
	return FALSE;
	_state_1:
	g_async_initable_init_finish ((GAsyncInitable*) _data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_object_unref0 (_data_->conn);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = (TrackerSparqlConnection*) _data_->conn;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

